src/config/routes.rb
Rails.application.routes.draw do
  resources :courses
  get 'admin/users'

  get '/dashboard', to: 'dashboard#index', as: :dashboard

  resources :users, only: [:new, :create]
  get '/users/profile', to: 'users#profile'
  get '/users/password', to: 'users#password'
  put '/users/change_password', to: 'users#change_password'
  put '/users/:id/change_role_to/:role', to: 'users#change_role', as: :users_change_role

  get '/sign_up', to: 'users#new', as: :sign_up

  resources :sessions, only: [:new, :create, :destroy]
  get '/sign_in', to: 'sessions#new', as: :sign_in
  delete '/sign_out', to: 'sessions#destroy', as: :sign_out

  get '/about', to: 'static_pages#about', as: :about
  get '/contact', to:'static_pages#contact', as: :contact

  resources :quizzes do
    member do
      get :attempt
      post :result
    end
  end

  root 'static_pages#home'


  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

src/app/models/ability.rb
class Ability
  include CanCan::Ability

  def initialize(user)
    # Define abilities for the passed in user here. For example:

    user ||= User.new # nil guard; creates a new user object
    if user.role?('admin')
      can :manage, :all
    elsif user.role?('teacher')
      can :index, :dashboard
      can :read, User, id: user.id
      can :manage, [Course, Quiz, Question, Answer]
    elsif user.role?('student')
      can :index, :dashboard
      can :update, User, id: user.id
      can :read, User, id: user.id
      can :read, [Course, Quiz, Question, Answer]
      can :attempt, [Quiz, Question, Answer]
      can :result, [Quiz, Question, Answer]
    end

    #
    # The first argument to `can` is the action you are giving the user
    # permission to do.
    # If you pass :manage it will apply to every action. Other common actions
    # here are :read, :create, :update and :destroy.
    #
    # The second argument is the resource the user can perform the action on.
    # If you pass :all it will apply to every resource. Otherwise pass a Ruby
    # class of the resource.
    #
    # The third argument is an optional hash of conditions to further filter the
    # objects.
    # For example, here the user can only update published articles.
    #
    #   can :update, Article, :published => true
    #
    # See the wiki for details:
    # https://github.com/CanCanCommunity/cancancan/wiki/Defining-Abilities
  end
end

src/app/models/answer.rb
class Answer < ApplicationRecord
	belongs_to :question
end

src/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

src/app/models/course.rb
class Course < ApplicationRecord
  belongs_to :teacher, class_name: "User"
  has_and_belongs_to_many :students, join_table: :courses_students, class_name: "User"
  accepts_nested_attributes_for :students
	has_many :quizzes, :dependent => :destroy
end

src/app/models/question.rb
class Question < ApplicationRecord
	belongs_to :quiz
	has_many :answers, :dependent => :destroy
	accepts_nested_attributes_for :answers, :reject_if => lambda { |a| a[:content].blank? }, :allow_destroy => true
end

src/app/models/quiz.rb
class Quiz < ApplicationRecord
  validates :title, presence: true
  has_many :questions, :dependent => :destroy
  accepts_nested_attributes_for :questions, :reject_if => lambda { |a| a[:content].blank? }, :allow_destroy => true
  belongs_to :course
end

src/app/models/result.rb
class Result < ApplicationRecord
end

src/app/models/user.rb
class User < ApplicationRecord
  authenticates_with_sorcery!

  has_and_belongs_to_many :courses, class_name: "Course"

  validates :password, length: { minimum: 3 }, if: :new_user?

  validates :password, confirmation: true
  validates :email, uniqueness: true
  validates :email, uniqueness: true, email_format: { message: 'has invalid format' }

  enum role: {
    student: 0,
    teacher: 1,
    admin: 2
  }

  def change_password!(new_password)
    self.send(:"#{sorcery_config.password_attribute_name}=", new_password)
    sorcery_adapter.save
  end

  def role?(role_name)
    role == role_name
  end

  private
  def new_user?
    new_record?
  end
end

src/app/controllers/admin_controller.rb
class AdminController < ApplicationController
  authorize_resource :class => false

  def users
    @users = User.all
  end
end

src/app/controllers/answers_controller.rb
class AnswersController < ApplicationController
  load_and_authorize_resource
end

src/app/controllers/courses_controller.rb
class CoursesController < ApplicationController
  before_action :set_course, only: [:show, :edit, :update, :destroy]
  load_and_authorize_resource

  # GET /courses
  # GET /courses.json
  def index
    @courses = Course.all
  end

  # GET /courses/1
  def show
		@course = Course.find(params[:id])
  end

  # GET /courses/new
  def new
    @course = Course.new
  end

  # GET /courses/1/edit
  def edit
  end

  # POST /courses
  def create
    @course = Course.new(course_params)

    if @course.save
      flash[:success] = 'Course was successfully created.'
      redirect_to @course
    else
      render :new
    end
  end

  # PATCH/PUT /courses/1
  def update
    if @course.update(course_params)
      flash[:success] = 'Course was successfully updated.'
      redirect_to @course
    else
      render :edit
    end
  end

  # DELETE /courses/1
  # DELETE /courses/1.json
  def destroy
    @course.destroy
    flash[:success] = 'Course was successfully destroyed.'
    redirect_to courses_url
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_course
      @course = Course.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def course_params
      params.require(:course).permit(:name, :teacher_id, student_ids: [])
    end
end

src/app/controllers/users_controller.rb
class UsersController < ApplicationController
  skip_before_action :require_login, only: [:new, :create]
  skip_authorization_check only: [:new, :create]

  def new
    @user = User.new
  end

  def create
    @user = User.new(user_params)
    if @user.save
      login(params[:user][:email], params[:user][:password])
      flash[:success] = 'Welcome!'
      redirect_to dashboard_path
    else
      render 'new'
    end
  end

  def password
    render 'change_password'
    authorize! :update, User
  end

  def change_password
    @user = User.find(current_user.id)

    return if @user.blank?

    @user.password_confirmation = params[:user][:password_confirmation]
    if @user.change_password!(params[:user][:password])
      flash[:success] = 'Password was successfully updated.'
      redirect_to dashboard_path
    else
      render 'change_password'
    end
      authorize! :update, User
  end

  def change_role
    user = User.find(params[:id])

    if user.update(role: params[:role])
      flash[:success] = 'Role updated!'
      redirect_to admin_users_path
    else
      flash[:danger] = 'Role update failed!'
      redirect_to admin_users_path
    end
    authorize! :update, User
  end

  def profile
    @user = User.find(current_user.id)
    authorize! :read, User
  end

  private

  def user_params
    params.require(:user).permit(:email, :password, :password_confirmation, :username)
  end
end

src/app/helpers/admin_helper.rb
module AdminHelper
end

src/app/helpers/application_helper.rb
module ApplicationHelper
	def link_to_remove_fields(name, f)
      f.hidden_field(:_destroy) + link_to(name, "#", :class => "link_to_remove_fields" )
    end

    def link_to_add_fields(name, f, association)
      new_object = f.object.class.reflect_on_association(association).klass.new
      fields = f.fields_for(association, new_object, :child_index => "new_#{association}") do |builder|
        render(association.to_s.singularize + "_fields", :f => builder)
      end
      link_to(name, "#", "data-association" => "#{association}" , "data-content" => "#{fields}", :class => "link_to_add_fields" )
    end
end

src/app/helpers/courses_helper.rb
module CoursesHelper
end

src/app/helpers/dashboard_helper.rb
module DashboardHelper
end

src/app/helpers/quizzes_helper.rb
module QuizzesHelper
end

src/app/helpers/sessions_helper.rb
module SessionsHelper
end

src/app/helpers/static_pages_helper.rb
module StaticPagesHelper
end

src/app/helpers/users_helper.rb
module UsersHelper
end

src/app/views/admin/users.html.erb
<h1>Manage users</h1>

<table class="table table-striped">
  <thead>
    <tr>
      <th>Username</th>
      <th>E-Mail</th>
      <th>Role</th>
    </tr>
  </thead>
  <tbody>
    <% @users.each do |user|%>
    <tr>
      <td><%= user.username %></td>
      <td><%= user.email %></td>
      <td>
        <% if user.id == 1 %>
          <%= user.role.capitalize %>
        <% else %>
        <div class="btn-group" role="group" aria-label="choose role">
          <% User.roles.keys.each do |role|%>
          <%= link_to role.capitalize, users_change_role_path(user, role),
              class: "btn btn-default",
              type: "button",
              disabled: user.role?(role),
              method: :put,
              role: role %>
          <% end %>
        </div>
        <% end %>
      </td>
    </tr>
    <% end %>
  </tbody>
</table>

src/app/views/layouts/_footer.html.erb
<footer class="footer">
  <span>&copy; <%= Time.now.year  %> Heterogeneous Knowledge</span>
  <span><%= link_to 'About', about_path %></span>
  <span><%= link_to 'Contact', contact_path %></span>
</footer>

src/app/views/layouts/_guest_navigation.html.erb
<ul class="nav navbar-nav"></ul>
<ul class="nav navbar-nav navbar-right">
  <li><%= link_to 'Sign In', sign_in_path %></li>
  <li><%= link_to 'Sign Up', sign_up_path %></li>
</ul>

src/app/views/layouts/_header.html.erb
<header>
  <nav class="navbar navbar-default navbar-fixed-top">
    <div class="container">
      <div class="navbar-header">
        <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
          <span class="sr-only">Toggle navigation</span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <%= link_to(root_path, class: "navbar-brand") do %>
          <%= image_tag("logo.svg", alt: "HKET", height: "40") %>
        <% end %>
      </div>
      <div id="navbar" class="navbar-collapse collapse">
        <% if current_user != nil %>
          <%= render 'layouts/navigation' %>
        <% else %>
          <%= render 'layouts/guest_navigation' %>
        <% end %>
      </div>
      <!--/.nav-collapse -->
    </div>
  </nav>
</header>

src/app/views/layouts/_navigation.html.erb
<ul class="nav navbar-nav">
  <li><%= link_to 'Quizzes', quizzes_path %></li>
  <li><%= link_to 'Courses', courses_path %></li>
  <% if can? :manage, User %>
  <li><%= link_to 'Manage User Permission', admin_users_path %></li>
  <% end %>
</ul>
<ul class="nav navbar-nav navbar-right">
  <li class="dropdown">
    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false"><%= current_user.username %>
      <span class="caret"></span>
    </a>
    <ul class="dropdown-menu">
      <li><%= link_to 'Your Profile', users_profile_path %></li>
      <li><%= link_to 'Change Password', users_password_path %></li>
      <li><%= link_to 'Your Grades', '#' %></li>
      <li role="separator" class="divider"></li>
      <li><%= link_to 'Log Out', sign_out_path, method: :delete %></li>
    </ul>
  </li>
</ul>

src/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no">
    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
    <title>HK Examination</title>
    <%= favicon_link_tag 'favicon.png', type: 'image/png' %>
    <%= csrf_meta_tags %>
    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
  </head>
  <body>
    <%= render 'layouts/header' %>

    <!-- Begin page content -->
    <div class="container">
      <% flash.each do |key, value| %>
      <div class="alert alert-<%= key %> alert-dismissible" role="alert">
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
        <%= value %>
      </div>
      <% end %>

      <%= yield %>

      <%= render 'layouts/footer' %>
    </div>

    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </body>
</html>